#if !defined(AFX_DESTDLG_H__55360A78_485C_11D5_84FB_76788A000000__INCLUDED_)
#define AFX_DESTDLG_H__55360A78_485C_11D5_84FB_76788A000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DestDlg.h : header file
//

class CImageBitmap;

class CDestCorner : public CPoint
{
public:
	CDestCorner();
	virtual ~CDestCorner();
	void Create(int X, int Y, int Index);
	void DrawIcon(CDC *pDC);
	void AdjustAOI(int X, int Y);
	void AdjustAOI(CPoint *HotSpot, CPoint *Offset);
	BOOL PtInRect(POINT Point) {return m_AOI.PtInRect(Point);};
private:
	HICON m_Icon;
	CRect m_AOI;
	CRect m_Offset;
	CPoint m_HotSpot[2];
};

/////////////////////////////////////////////////////////////////////////////
// CDestDlg dialog

class CDestDlg : public CDialog
{
// Construction
public:
	CDestDlg(CImageBitmap *Image, CImageBitmap *Source, CWnd* pParent = NULL);   // standard constructor
	virtual ~CDestDlg();
// Dialog Data
	//{{AFX_DATA(CDestDlg)
	enum { IDD = IDD_DEST };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDestDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CDestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnClose();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CImageBitmap *m_Bitmap;
	CImageBitmap *m_Source;
	void SetSize(int cx, int cy);
	CDestCorner m_Corner[4];
	CDestCorner *m_Active;
	CPoint m_Offset;
	BOOL m_ShowLines;
public:
	void Transform(CImageBitmap *In = 0);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DESTDLG_H__55360A78_485C_11D5_84FB_76788A000000__INCLUDED_)
