// glrotateDlg.cpp : implementation file
//
// Author  : S. Qureshi
// Created : May, 2001
//
// COPYRIGHT 2001 
// This source code may be used and modified without restriction 
// as long as the copyright and author data remains intact.

#include <math.h>
#include "stdafx.h"
#include "glrotate.h"
#include "glrotateDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGlrotateDlg dialog

CGlrotateDlg::CGlrotateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGlrotateDlg::IDD, pParent), 
          m_pImageRGB(0), 
          m_iTexName(0), 
          m_fImageWidth(0.0),
          m_fImageHeight(0.0),
          m_iDisplayListId(0),
          m_fTheta(0.0)
{
	//{{AFX_DATA_INIT(CGlrotateDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGlrotateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGlrotateDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGlrotateDlg, CDialog)
	//{{AFX_MSG_MAP(CGlrotateDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(IDM_LOAD_BMP, OnLoadBmpImage)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_COMMAND(IDM_EXIT, OnExit)
	ON_WM_KEYDOWN()
	ON_COMMAND(IDM_HELP, OnHelp)
	ON_COMMAND(IDM_SAVE_BMP, OnSaveBmp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGlrotateDlg message handlers

BOOL CGlrotateDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGlrotateDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGlrotateDlg::OnPaint() 
{
  if (IsIconic())
  {
    CPaintDC dc(this); // device context for painting

    SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

    // Center icon in client rectangle
    int cxIcon = GetSystemMetrics(SM_CXICON);
    int cyIcon = GetSystemMetrics(SM_CYICON);
    CRect rect;
    GetClientRect(&rect);
    int x = (rect.Width() - cxIcon + 1) / 2;
    int y = (rect.Height() - cyIcon + 1) / 2;

    // Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
  {
    CDialog::OnPaint();

    this->RedrawScene();
  }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGlrotateDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGlrotateDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
  // CG: This block was added by the Pop-up Menu component
  {
    if (point.x == -1 && point.y == -1)
    {
      //keystroke invocation
      CRect rect;
      GetClientRect(rect);
      ClientToScreen(rect);

      point = rect.TopLeft();
      point.Offset(5, 5);
    }

    CMenu menu;
    VERIFY(menu.LoadMenu(IDR_MENU));

    CMenu* pPopup = menu.GetSubMenu(0);
    ASSERT(pPopup != NULL);
    CWnd* pWndPopupOwner = this;

    //              According to MSDN these lines must be commented out due
    //              to a bug in the development environment
    //		while (pWndPopupOwner->GetStyle() & WS_CHILD)
    //			pWndPopupOwner = pWndPopupOwner->GetParent();

    pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
	                   pWndPopupOwner);
  }	
}

void CGlrotateDlg::OnLoadBmpImage() 
{
  // show a file open dialog box, prompting user for location of bitmap file ...
  CFileDialog dlg(TRUE, 
                  NULL, 
                  NULL, 
	          (DWORD) OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
                  "BMP Image Files (*.bmp)|*.bmp|"
                  "All Files (*.*)|*.*|", 
                  NULL);

  if (dlg.DoModal() == IDOK) 
  {
    // set the window title to this image filename ...
    CString filename = dlg.GetFileName();
    this->SetWindowText((LPCSTR)filename);

    CString pathname = dlg.GetPathName();

    if (m_pImageRGB)
      delete m_pImageRGB;

    // use this nice GL utility function that reads in a BMP image,
    // and converts BGR to RGB.
    if (NULL == (m_pImageRGB = auxDIBImageLoadA((LPCSTR)pathname)))
    {
      this->MessageBox("Not a valid BMP file.", "Image Load Error", MB_OK|MB_ICONERROR);
      return;
    }

    this->TexMapScalePow2();
    this->ResizeDialog();
    this->InitOpenGL();

    m_fTheta = 0.0;

    // force Windows to redraw the scene ...
    this->InvalidateRect(NULL, FALSE);
    this->UpdateWindow();
  }
}

int CGlrotateDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
  if (CDialog::OnCreate(lpCreateStruct) == -1)
    return -1;

  HWND hWnd = this->GetSafeHwnd();
  HDC hDC = ::GetDC(hWnd);

  if(this->SetWindowPixelFormat(hDC)==FALSE)
    TRACE("CGlrotateDlg::OnCreate() - setWindowPixelFormat() FAILED!!!\r\n");

  if(this->CreateViewGLContext(hDC)==FALSE)
    TRACE("CGlrotateDlg::OnCreate() - wglCreateContext() FAILED!!!\r\n");	

  return 0;
}

BOOL CGlrotateDlg::SetWindowPixelFormat(HDC hDC)
{
  //
  // Fill in the Pixel Format Descriptor
  //

  PIXELFORMATDESCRIPTOR pfd;
  memset(&pfd,0, sizeof(PIXELFORMATDESCRIPTOR)) ;
  pfd.nSize = sizeof(PIXELFORMATDESCRIPTOR);  
  pfd.nVersion = 1 ;                           // Version number
  pfd.dwFlags =      PFD_DRAW_TO_WINDOW |      
                     PFD_SUPPORT_OPENGL |      // support OpenGL
                     PFD_DOUBLEBUFFER;         // double buffered 
  pfd.iPixelType = PFD_TYPE_RGBA;
  pfd.cColorBits = 24 ;			       // 24 of bits for color
  pfd.cDepthBits = 32 ;			       // 32-bit depth buffer
  pfd.iLayerType = PFD_MAIN_PLANE ;            // Layer type

  m_iGLPixelIndex = ChoosePixelFormat(hDC,&pfd);
  if (!m_iGLPixelIndex) // Choose default
  {
    m_iGLPixelIndex = 1;
    if(0 == DescribePixelFormat(hDC,
                                m_iGLPixelIndex,
	                        sizeof(PIXELFORMATDESCRIPTOR),
                                &pfd))
    {
      return FALSE;
    }
  }

  if (FALSE == SetPixelFormat(hDC,m_iGLPixelIndex,&pfd))
  {
    return FALSE;
  }

  return TRUE;
}

BOOL CGlrotateDlg::CreateViewGLContext(HDC hDC)
{
  m_hGLContext = wglCreateContext(hDC);

  if(m_hGLContext==NULL)
    return FALSE;

  if(wglMakeCurrent(hDC,m_hGLContext)==FALSE)
  {
    TRACE("CGlrotateDlg::CreateViewGLContext() - wglMakeCurrent() FAILED!!!\r\n");
    return FALSE;
  }

  return TRUE;
}

void CGlrotateDlg::ResizeDialog()
{
  // ensure that the OpenGL rendering context is EXACTLY the dimensions we require ...
  CRect clientRect, currWindowRect;
  DWORD dwStyle = this->GetStyle(),
        dwExStyle = this->GetExStyle();
  
  this->GetWindowRect(currWindowRect);
  this->GetClientRect(clientRect);

  clientRect.right  = clientRect.left + m_image.width;
  clientRect.bottom = clientRect.top  + m_image.height;

  if (FALSE == AdjustWindowRectEx(clientRect, dwStyle, FALSE, dwExStyle))
  {
    TRACE("CGlrotateDlg::ResizeDialog() - AdjustWindowRectEx() FAILED!!!\r\n");
  }

  this->SetWindowPos(0, 
                     currWindowRect.left, 
                     currWindowRect.top, 
                     clientRect.Width(), 
                     clientRect.Height(), 
                     SWP_SHOWWINDOW);
}

void CGlrotateDlg::InitOpenGL()
{
  glDisable(GL_DEPTH_TEST);

  glClearColor (0.0, 0.0, 0.0, 0.0);

  // set up an orthographic projection ...
  GLfloat halfWidth  = m_fImageWidth/2.f,
          halfHeight = m_fImageHeight/2.f;
  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity ();
  gluOrtho2D(-halfWidth+0.5f,  // left
             halfWidth-0.5,    // right
             -halfHeight+0.5f, // bottom
             halfHeight-0.5f); // top

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity ();

  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  glPixelStorei(GL_PACK_ALIGNMENT, 1);

  // create an OpenGL texture map ...
  if (m_iTexName)
  {
    if (GL_TRUE == glIsTexture(m_iTexName))
    {
      glDeleteTextures(1, &m_iTexName);
    }
  }
  
  glGenTextures(1, &m_iTexName);
  glBindTexture(GL_TEXTURE_2D, m_iTexName);

  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

  glEnable(GL_TEXTURE_2D);

  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);  

  glTexImage2D(GL_TEXTURE_2D, 
               0, 
               GL_RGB, 
               m_image.width, 
               m_image.height, 
               0, 
               GL_RGB, 
               GL_UNSIGNED_BYTE, 
               m_image.data.begin());
  
  // create an OpenGL display list ...
  if (m_iDisplayListId)
  {
    if (GL_TRUE == glIsList(m_iDisplayListId))
    {
      glDeleteLists(m_iDisplayListId, 1);
    }
  }

  m_iDisplayListId = glGenLists(1);

  glNewList(m_iDisplayListId, GL_COMPILE);

    glBegin(GL_QUADS);

      glColor3f(1.0, 1.0, 1.0);

      // pixel to texel mapping ...
      GLfloat polyW = halfWidth+0.5f,
              polyH = halfHeight+0.5f;
      glTexCoord2f(0.0, 0.0); glVertex3f(-polyW,-polyH,0);
      glTexCoord2f(0.0, 1.0); glVertex3f(-polyW,polyH,0);
      glTexCoord2f(1.0, 1.0); glVertex3f(polyW,polyH,0);
      glTexCoord2f(1.0, 0.0); glVertex3f(polyW,-polyH,0);

    glEnd();
  
  glEndList();
}

void CGlrotateDlg::RedrawScene()
{
  if (m_hGLContext != wglGetCurrentContext())
  {
    if (FALSE == wglMakeCurrent(::GetDC(this->GetSafeHwnd()),m_hGLContext))
    {
      TRACE("CGlrotateDlg::RedrawScene() - wglMakeCurrent() call FAILED!\r\n");
      return;
    }
  }

  CPaintDC dc(this); // device context for painting  
  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glPushMatrix();

  glRotatef(m_fTheta, 0.0, 0.0, 1.0);
  glTranslatef(0.0, 0.0, 0.0);

  glCallList(m_iDisplayListId);

  glPopMatrix();

  glFlush();

  SwapBuffers(dc.m_ps.hdc);
}

void CGlrotateDlg::WriteBmpFile(CString &imagePathname, GLubyte *pImageData)
{
  FILE *fp = fopen((LPCSTR)imagePathname, "wb");

  if (!fp || !pImageData)
  {
    this->MessageBox("Unable to save file", "Image Save Error", MB_OK|MB_ICONERROR);
    return;
  }

  // there are a myriad of ways to save BMP files.
  // for simplicity sake, save as truecolor RGB (24 bpp) ...
  
  int bpp = 24;
  int bmpInfoSize = sizeof(BITMAPINFOHEADER);
  BITMAPFILEHEADER header; // bmp file header
  int bitmapSize; // # of bytes taken up RGB image data (including padding)

  // calculate bitmapSize, remember no palette for truecolor RGB
  bitmapSize = (m_image.width * bpp + 7) / 8 * abs(m_image.height);

  // this is the total file size
  int size = sizeof(BITMAPFILEHEADER) + bmpInfoSize + bitmapSize;

  // output BMP file header, bitmap info, and then the RGB data
  header.bfType      = 'MB';
  header.bfSize      = size;
  header.bfReserved1 = 0;
  header.bfReserved2 = 0;
  header.bfOffBits   = sizeof(BITMAPFILEHEADER) + bmpInfoSize;

  if (fwrite(&header, 1, sizeof(BITMAPFILEHEADER), fp) < sizeof(BITMAPFILEHEADER))
  {
    /* Couldn't write the file header - return... */
    fclose(fp);
    this->MessageBox("Unable to save file", "Image Save Error", MB_OK|MB_ICONERROR);
    return;
  }

  // we've written the file header, now write the BMP header ...
  BITMAPINFO bmpInfoHeader;
  bmpInfoHeader.bmiHeader.biSize = 40; // size of this struct
  bmpInfoHeader.bmiHeader.biWidth = m_image.width;
  bmpInfoHeader.bmiHeader.biHeight = m_image.height;
  bmpInfoHeader.bmiHeader.biPlanes = 1;
  bmpInfoHeader.bmiHeader.biBitCount = bpp;
  bmpInfoHeader.bmiHeader.biCompression = BI_RGB; // uncompressed format
  bmpInfoHeader.bmiHeader.biSizeImage = bitmapSize; // size of image bitmap
  bmpInfoHeader.bmiHeader.biXPelsPerMeter = 0;
  bmpInfoHeader.bmiHeader.biYPelsPerMeter = 0;
  bmpInfoHeader.bmiHeader.biClrUsed = 0; // not required for truecolor RGB
  bmpInfoHeader.bmiHeader.biClrImportant = 0; // see above

  if (fwrite(&bmpInfoHeader, 1, bmpInfoSize, fp) < bmpInfoSize)
  {
    /* Couldn't write the bitmap header - return... */
    fclose(fp);
    this->MessageBox("Unable to save file", "Image Save Error", MB_OK|MB_ICONERROR);
    return;
  }
  
  // now we are  ready (finally!) to write out the pixel data.
  //
  // A few caveats though 1st :
  //
  // Windows DIB color components are ordered the opposite of 
  // OpenGL, i.e. it goes blue-green-red as opposed to GL's RGB
  // color triplets.  
  //
  // Image scanlines are aligned on DWORD boundaries.  
  //
  // And last but not least, BMP images are written with the 
  // bottom row of the image written first.  Since GL's origin
  // is at the bottom-left, this works out perfectly for us :)
  
  int padding = (4 - ((m_image.width*3) % 4)) & 0x03;

  for (int ii=0; ii<m_image.height; ii++)
  {
    GLubyte *pRGB = pImageData + (ii*m_image.width*3);
    for (int jj=0; jj<m_image.width; jj++)
    {
      putc(pRGB[2], fp); // blue component
      putc(pRGB[1], fp); // green component
      putc(pRGB[0], fp); // red component
      pRGB += 3;
    }

    // now add the necessary padding for DWORD alignment ...
    for (int kk=0; kk<padding; kk++)
      putc(0, fp);
  }

  fclose(fp);
}

void CGlrotateDlg::TexMapScalePow2()
{
  // this method has been adapted from Dale Rogerson's
  // "OpenGL VII: Scratching the Surface of Texture Mapping" (MSDN)

  // make current so that glGetIntegerv() & gluScaleImage() work correctly ...
  if (wglGetCurrentContext() != NULL)
  {
    if (FALSE == wglMakeCurrent(::GetDC(this->GetSafeHwnd()),m_hGLContext))
    {
      TRACE("CGlrotateDlg::TexMapScalePow2() - wglMakeCurrent() FAILED!!!\r\n");
      this->MessageBox("Unable to scale image to a power of 2", "Image Load Error", MB_OK|MB_ICONERROR);
      return;
    }
  }

  GLint glMaxTexDim;
  double xPow2, yPow2;
  int ixPow2, iyPow2;
  int xSize2, ySize2;

  glGetIntegerv(GL_MAX_TEXTURE_SIZE, &glMaxTexDim);

  if (m_pImageRGB->sizeX <= glMaxTexDim)
    xPow2 = log((double)m_pImageRGB->sizeX) / log(2.0);
  else
    xPow2 = log((double)glMaxTexDim) / log(2.0);

  if (m_pImageRGB->sizeY <= glMaxTexDim)
    yPow2 = log((double)m_pImageRGB->sizeY) / log(2.0);
  else
    yPow2 = log((double)glMaxTexDim) / log(2.0);

  ixPow2 = (int)xPow2;
  iyPow2 = (int)yPow2;

  bool xScalingNeeded = true, yScalingNeeded = true;
  if (xPow2 != (double)ixPow2)
    ixPow2++;
  else
    xScalingNeeded = false;
  if (yPow2 != (double)iyPow2)
    iyPow2++;
  else
    yScalingNeeded = false;

  xSize2 = 1 << ixPow2;
  ySize2 = 1 << iyPow2;

  m_image.data.resize(xSize2 * ySize2 * 3);

  if (xScalingNeeded && yScalingNeeded)
  { 
    GLenum status = gluScaleImage(GL_RGB, 
                                  m_pImageRGB->sizeX, 
                                  m_pImageRGB->sizeY,
                                  GL_UNSIGNED_BYTE, 
                                  m_pImageRGB->data,
                                  xSize2, 
                                  ySize2, 
                                  GL_UNSIGNED_BYTE,
                                  m_image.data.begin());

    if (status != 0)
    {
      CString errorString(gluErrorString(status));
      this->MessageBox(errorString, "Image Load Error", MB_OK|MB_ICONERROR);
    }
  }
  else
  {
    // no scaling necessary, just copy data into structure ...
    std::copy(m_pImageRGB->data, m_pImageRGB->data+(xSize2*ySize2*3), m_image.data.begin());
  }

  m_image.width  = xSize2;
  m_image.height = ySize2;

  m_fImageWidth  = (float)xSize2;
  m_fImageHeight = (float)ySize2;
}

void CGlrotateDlg::OnDestroy() 
{
  CDialog::OnDestroy();
  
  if (wglGetCurrentContext() != NULL)
    if (FALSE == wglMakeCurrent(NULL,NULL))
      TRACE("CGlrotateDlg::OnDestroy() - wglMakeCurrent() FAILED!!!\r\n");

  if (m_hGLContext != NULL)
  {
    wglDeleteContext(m_hGLContext);
    m_hGLContext = NULL;
  }	
  
  if (m_pImageRGB)
  {
    delete m_pImageRGB;
    m_pImageRGB = 0;
  }
}

void CGlrotateDlg::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);

  glViewport(0, 0, cx, cy);

  glDrawBuffer(GL_BACK);
}

void CGlrotateDlg::OnExit() 
{
  CDialog::OnOK(); // This will close the dialog and DoModal will return.
}

void CGlrotateDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
  char lsChar(MapVirtualKey(nChar, 2)); // current character being pressed

  switch (lsChar)
  {
  case ',':
    m_fTheta -= 2.f;
    if (m_fTheta<-360.f)
      m_fTheta += 360.f;
    break;

  case '.':
    m_fTheta += 2.f;
    if (m_fTheta>360.f)
      m_fTheta -= 360.f;
    break;

  case '0':
    m_fTheta = 0.f;
    break;
  }

  TRACE("CGlrotateDlg::OnKeyDown() - theta = %.2f degrees\r\n", m_fTheta);

  // force Windows to redraw the scene ...
  this->InvalidateRect(NULL, FALSE);
  this->UpdateWindow();

  CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CGlrotateDlg::OnHelp() 
{
  char help[] = "< : rotate image clock-wise\r\n"
                "> : rotate image counter clock-wise\r\n"
                "0 : reset image rotation\r\n"
                "ESC : exit application\r\n";

  this->MessageBox(help, "Help");
}

void CGlrotateDlg::OnSaveBmp() 
{
  if (!m_pImageRGB)
  {
    this->MessageBox("No Image Data!", "Image Save Error", MB_OK|MB_ICONERROR);
    return;
  }

  if (FALSE == this->SetForegroundWindow())
  {
    TRACE("CDrCGlrotateDlgrRC::OnSaveBmp() - SetForegroundWindow() called FAILED!!!\r\n");
    this->MessageBox("Unable to read frame buffer", "Image Save Error", MB_OK|MB_ICONERROR);
    return;
  }

  // disable window updates while we are busy reading frame buffer ...
  if (FALSE == this->LockWindowUpdate())
  {
    TRACE("CDrCGlrotateDlgrRC::OnSaveBmp() - LockWindowUpdate() called FAILED!!!\r\n");
    this->MessageBox("Unable to read frame buffer", "Image Save Error", MB_OK|MB_ICONERROR);
    return;
  }
    
  // now ready to read the pixel pixel data ...
  std::vector<GLubyte> pixelData(m_image.width*m_image.height*3);
  glReadPixels(0, 
               0, 
               m_image.width, 
               m_image.height, 
               GL_RGB, 
               GL_UNSIGNED_BYTE, 
               pixelData.begin());

  // done reading pixels, now we can reenable window updates ...
  this->UnlockWindowUpdate();

  // bring up a dialog box prompting user for filename
  CFileDialog dlg(FALSE, 
                  NULL, 
                  NULL, 
	          (DWORD) OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
                  "BMP Image Files (*.bmp)|*.bmp|"
                  "All Files (*.*)|*.*|", 
                  NULL);

  if (dlg.DoModal() == IDOK) 
  {
    // add ".bmp" extension if necessary
    CString filename = dlg.GetPathName(),
            fileExt = dlg.GetFileExt();

    if (fileExt.IsEmpty())
      filename += ".bmp";

    this->WriteBmpFile(filename, pixelData.begin());
  }
}
