// trickDlg.cpp : implementation file
//

#include "stdafx.h"
#include "newtrick.h"
#include "source.h"
#include "trickDlg.h"
#include "destdlg.h"
#include "image.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD) {
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewtrickDlg dialog

CNewtrickDlg::CNewtrickDlg(CWnd* pParent /*=NULL*/)  // ) {
		: CDialog(CNewtrickDlg::IDD, pParent) {
	//{{AFX_DATA_INIT(CNewtrickDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_SourceDlg = 0;
	m_DestDlg = 0;
}

CNewtrickDlg::~CNewtrickDlg() {
	if (m_SourceDlg) delete m_SourceDlg;
	m_SourceDlg = 0;
	if (m_DestDlg) delete m_DestDlg;
	m_DestDlg = 0;
}

void CNewtrickDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewtrickDlg)
	DDX_Control(pDX, IDC_DEST, m_Dest);
	DDX_Control(pDX, IDC_TRANSFORM, m_Transform);
	DDX_Control(pDX, IDC_BITMAP, m_Bitmap);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNewtrickDlg, CDialog)
	//{{AFX_MSG_MAP(CNewtrickDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_TRANSFORM, OnTransform)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_DEST, OnDest)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewtrickDlg message handlers

BOOL CNewtrickDlg::OnInitDialog() {
	CDialog::OnInitDialog();
	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX,
				strAboutMenu);
		}
	}
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_SourceDlg = new CSourceBitmapControl(&m_Bitmap);
	m_SourceDlgSize.OnInitDialog(this, &m_Bitmap);
	m_Bitmap.SetChild(m_SourceDlg);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNewtrickDlg::OnSysCommand(UINT nID, LPARAM lParam) {
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else	CDialog::OnSysCommand(nID, lParam);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNewtrickDlg::OnPaint() {
	if (IsIconic())	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else	CDialog::OnPaint();
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNewtrickDlg::OnQueryDragIcon(){return (HCURSOR) m_hIcon;}

void CNewtrickDlg::OnOpen() {if (m_SourceDlg) m_SourceDlg->LoadBitmap();}

void CNewtrickDlg::OnTransform() {
	if (m_DestDlg && m_SourceDlg) m_DestDlg->Transform(*m_SourceDlg);
}

void CNewtrickDlg::OnSize(UINT nType, int cx, int cy) {
	CDialog::OnSize(nType, cx, cy);
	if (m_SourceDlg) m_SourceDlgSize.OnSize(nType, cx, cy);
}

void CNewtrickDlg::OnDest() {
	if (!m_SourceDlg) return;
	CImageBitmap *source = *m_SourceDlg;
	if (!source) return;
	if (!source->BMPLoaded()) return;
	CFileDialog d(TRUE, ".bmp", 0, 0, "Bitmap Files (*.bmp)|*.bmp||");
	if (d.DoModal() != IDOK) return;
	CImageBitmap *dest = new CImageBitmap;
	if (dest->LoadBMPFile(d.GetPathName())) {
		if (m_DestDlg) delete m_DestDlg;
		m_DestDlg = new CDestDlg(dest, source);
	}
	else	delete dest;	
}

void CNewtrickDlg::OnClose() {
	if (m_DestDlg) delete m_DestDlg;
	m_DestDlg = 0;
	CDialog::OnClose();
}
