#include "stdafx.h"
#include "classext.h"

dbCObArray::dbCObArray() { p_index = -1; p_autodelete = TRUE; }
dbCObArray::~dbCObArray() { if (p_autodelete) Empty(); }
int dbCObArray::IsEmpty() { return (GetUpperBound() == -1); }
void dbCObArray::SetAutoDelete(BOOL sw) { p_autodelete = sw; }
void dbCObArray::SetIndex(int index) {	p_index = index;}
int dbCObArray::GetIndex() { return (p_index);}

void dbCObArray::Empty() {
	int i, j = GetSize();

	for (i = 0; i < j; i++) delete GetAt(i);
	p_index = -1;
	if (j) RemoveAll();
}

CObject *dbCObArray::GetFirst() {
	p_index = GetUpperBound();
	if (p_index == -1) return(0);
	p_index = 0;
	return GetAt(p_index);
}

CObject *dbCObArray::GetNext() {
	if (p_index < 0) return(0);
	if (p_index >= GetUpperBound()) return(0);
	return GetAt(++p_index);
}

CObject *dbCObArray::GetLast() {
	p_index = GetUpperBound();
	if (p_index == -1) return(0);
	return GetAt(p_index);
}

CObject *dbCObArray::GetPrior() {
	if (p_index <= 0) return(0);
	if (p_index > GetUpperBound()) return(0);
	return GetAt(--p_index);
}

int dbCObArray::Find(CObject *cmp) {
	if (IsEmpty()) return(-1);
	CObject *tmp;
	int i, j = GetUpperBound();
	for (i = 0; i < j; i++) {
		tmp = GetAt(i);
		if (tmp == cmp) return(i);
	}
	return (-2);
}

void dbCObArray::Sort(int (__cdecl *cmp)(const void *, const void *),   // ) {
		int invert) {
	if (IsEmpty()) return;
	int i, j = GetSize();
	void **v = new void * [j];
	for (i = 0; i < j; i++) v[i] = (void *)GetAt(i);
	RemoveAll();
	qsort(v, j, sizeof(void *), cmp);
	for (i = 0; i < j && !invert; i++) Add((CObject *)v[i]);
	for (i = j; i > 0 && invert; ) Add((CObject *)v[--i]);
	delete v;
}

